/*
 *  Engine/Autocompletion.cs
 *  Copyright (C) 2006-2007 Marcin Krystian Krzywonos
 *  License: GNU/GPL version 2
 */


using System.Collections;
using System;
using System.IO;
using System.Xml;



namespace Incollector.Engine {
	
	/// <summary>Autocompletion class.</summary>
	public static class Autocompletion {
		
		private static Hashtable Fields = new Hashtable ();
		
		
		/// <summary>Adds a new text with speciefied data type (DataID) to list.</summary>
		public static void Add (string DataID, string text)
		{
			if (Fields [DataID] == null) {
				Fields [DataID] = new Gtk.EntryCompletion ();
				(Fields [DataID] as Gtk.EntryCompletion).TextColumn = 0;
				(Fields [DataID] as Gtk.EntryCompletion).Model = new Gtk.ListStore (typeof (string));
			}
			
			Gtk.ListStore model = (Fields [DataID] as Gtk.EntryCompletion).Model as Gtk.ListStore;
			Gtk.TreeIter itr;
			
			for (bool tmp = model.GetIterFirst (out itr); tmp == true; tmp = model.IterNext (ref itr))
				if (string.Compare ((model.GetValue (itr, 0) as string), text) == 0)
					return;
			
			model.AppendValues (new object [] {text});
		}
		
		
		/// <summary>Assigns fields to speciefied entry widget.</summary>
		public static void Assign (Gtk.Entry entry, string DataID)
		{
			if (Fields [DataID] == null)
				return;
			
			entry.Completion = Fields [DataID] as Gtk.EntryCompletion;
		}
	}
}
